using System;
using System.Reflection;
using System.Runtime.Remoting.Messaging;

namespace Goods
{
    /// <summary>
    /// Summary description for GoodsMessageSink.
    /// </summary>
    public class GoodsMessageSink : IMessageSink 
    {
        internal GoodsMessageSink(MarshalByRefObject target, IMessageSink next) 
        {
            this.next = next;
            this.target = target;
        }

        public IMessageSink NextSink 
        {
            get 
            { 
                return next;
            }
        }

        public IMessage SyncProcessMessage(IMessage call) 
        {
            IMethodMessage invocation = (IMethodMessage)call;
            string methodName = invocation.MethodName;

            if (methodName[0] == '_') 
            { 
                return NextSink.SyncProcessMessage(call);
            }
            MethodBase mb = invocation.MethodBase;
            ObjectHeader p = ((Persistent)target)._hdr();
            Metaobject mop = p.metaobject;

            int flags = 0;
            Object[] attribs = mb.GetCustomAttributes(typeof(MutatorAttribute), false);
            if (attribs.Length > 0)
            {
                flags |= Metaobject.MUTATOR;
                p.state |= ObjectState.DIRTY;
            } 
            attribs = mb.GetCustomAttributes(typeof(ConstantAttribute), false);
            if (attribs.Length == 0)
            {
                flags |= Metaobject.MUTATOR;
            } 
            /**/
            if (methodName == "FieldSetter") 
            {
                flags |= Metaobject.MUTATOR;
                p.state |= ObjectState.DIRTY;
            }
            /**/
            mop.preDaemon(p, flags);
            IMessage result = NextSink.SyncProcessMessage(call);
            mop.postDaemon(p, flags);
            return result;
        }

        public IMessageCtrl AsyncProcessMessage(IMessage call, IMessageSink destination) 
        {
            return NextSink.AsyncProcessMessage(call, destination);
        }

        private IMessageSink       next;
        private MarshalByRefObject target;
    }
}
