//-< NotOwnerError.java >--------------------------------------------*--------*
// GOODS                      Version 2.02       (c) 1998  GARRET    *     ?  *
// (Generic Object Oriented Database System)                         *   /\|  *
// Java Program Interface                                            *  /  \  *
//                          Created:     20-Jun-98    K.A. Knizhnik  * / [] \ *
//                          Last update: 10-Jul-98    K.A. Knizhnik  * GARRET *
//-------------------------------------------------------------------*--------*
// Error raised when thread tries to unlock resource, 
// which is not locked by this thread
//-------------------------------------------------------------------*--------*
namespace Goods
{
    using System;
	
    /// <summary>This error is thrown when thread releasing lock
    /// is not one who set this lock. This error can be thrown by 
    /// <code>Mutex</code> class.
    /// 
    /// </summary>
    /// <seealso cref=" Goods.Mutex
    /// 
    /// "/>
    public class NotOwnerError:ApplicationException
    {
        public NotOwnerError():base("Thread is not owner of resource")
        {
        }
    }
}