//-< SortedCollection.cs >-------------------------------------------*--------*
// GOODS                      Version 2.02       (c) 1998  GARRET    *     ?  *
// (Generic Object Oriented Database System)                         *   /\|  *
// C# Program Interface                                              *  /  \  *
//                          Created:     14-Feb-2004  K.A. Knizhnik  * / [] \ *
//                          Last update: 14-Feb-2004  K.A. Knizhnik  * GARRET *
//-------------------------------------------------------------------*--------*
// Peristent comparator abstraction used by sorted collection
//-------------------------------------------------------------------*--------*
namespace Goods
{
    /// <summary> Base class for persistent comparator used in SortedCollection class
    /// </summary>
    [Metaobject(typeof(OptimisticMetaobject))]
    public abstract class PersistentComparator : Persistent 
    {
        public PersistentComparator() {}
        
        protected PersistentComparator(Metaobject mop) : base(mop) {}

        /// <summary> 
        /// Compare two members of collection
        /// </summary>
        /// <param name="m1"> first members</param>
        /// <param name="m2"> second members</param>
        /// <returns>negative number if m1 &lt; m2, zero if m1 == m2 and positive number if m1 &gt; m2</returns>
        public abstract int CompareMembers(Persistent m1, Persistent m2);

        /// <summary>
        /// Compare member with specified search key
        /// </summary>
        /// <param name="mbr"> collection member</param>
        /// <param name="key"> search key</param>
        /// <returns>negative number if mbr &lt; key, zero if mbr == key and positive number if mbr &gt; key</returns>
        public abstract int CompareMemberWithKey(Persistent mbr, object key);
    }
}
