//-< SerializableObjectFactory.java >--------------------------------*--------*
// GOODS                      Version 2.02       (c) 1998  GARRET    *     ?  *
// (Generic Object Oriented Database System)                         *   /\|  *
// Java Program Interface                                            *  /  \  *
//                          Created:     26-Sep-2002  K.A. Knizhnik  * / [] \ *
//                          Last update: 26-Oct-2002  K.A. Knizhnik  * GARRET *
//-------------------------------------------------------------------*--------*
// Factory for raw binary objects using Java serialization mechanism
//-------------------------------------------------------------------*--------*
namespace Goods
{
    using System;
	
    /// <summary> Factory for raw binary objects using Java serialization mechanism
    /// </summary>
    public class SerializableObjectFactory : RawBinaryFactory
    {
        public virtual int size(Object obj)
        {
            if (obj == null)
            {
                return 0;
            }
            System.IO.MemoryStream mout = new System.IO.MemoryStream();
            formatter.Serialize(mout, obj);
            return (int)mout.Length;
        }
				
        public virtual int pack(Object obj, byte[] arr, int offs)
        {
            if (obj != null)
            {
                System.IO.MemoryStream mout = new System.IO.MemoryStream(arr, offs, arr.Length - offs, true);
                formatter.Serialize(mout, obj);
                return (int)mout.Length;
            }
            return 0;
        }
		
        public virtual Object unpack(Type cls, byte[] arr, int off, int size)
        {
            if (size == 0)
            {
                return null;
            }
            return  formatter.Deserialize(new System.IO.MemoryStream(arr, off, size));
        }
		
        public virtual bool supports(Type cls)
        {
            return typeof(System.Runtime.Serialization.ISerializable).IsAssignableFrom(cls);
        }
        
        public SerializableObjectFactory() 
        {
            formatter = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
        }

        internal System.Runtime.Serialization.Formatters.Binary.BinaryFormatter formatter;
    }
}