//-< PersistentString.java >-----------------------------------------*--------*
// GOODS                      Version 2.02       (c) 1998  GARRET    *     ?  *
// (Generic Object Oriented Database System)                         *   /\|  *
// GOODS Persistent Class Library                                    *  /  \  *
//                          Created:      1-Mar-2002  K.A. Knizhnik  * / [] \ *
//                          Last update:  1-Mar-2002  K.A. Knizhnik  * GARRET *
//-------------------------------------------------------------------*--------*
// Persistent version of String class
//-------------------------------------------------------------------*--------*

package goodslib;
import  goodsjpi.*;

/**
 * This class is used to store String objects passed in persistent collection classes.
 * It is inherited from <code>ArrayOfChar</code> and the only idea of introducing 
 * this class is to ptovide automatic converting back to String when
 * object of this type is retrieved.
 *
 * @author   K.A. Knizhnik
 * @version 1.0
 */

public class PersistentString extends ArrayOfChar {
    public PersistentString(String str) { 
	super(str);
    }

    public static Object getValue(Object value) { 
	return value instanceof PersistentString ? value.toString() : value;
    }
}
